#ifndef H_FFMSG001_PARSER
#define H_FFMSG001_PARSER

#include <BipCpi.h>
#include <BipCci.h>
#include <BipCni.h>

#if defined(__CCI_SOLARIS__) || defined(__CCI_HPUX__)|| defined(__CCI_LINUX__)/* 16/09/2001 */
#include <BipSampPluginUtil.h>
#endif

#include "node_utils.h"

typedef struct _ParserContext
{
   CciElement  *rootElement;
   CciChar      NextParserClassName[250];   /* The name of the next parser in the chain */
   CciBool      ParserType;
   void        *iCurrentElement;             /* Current element */
   void        *iBuffer;                     /* Buffer pointer */
   int          iSize;                       /* Size of input buffer in bytes */
   int          iIndex;                      /* Current position in the buffer */
} PARSER_CONTEXT_ST;

#if defined(__CCI_SOLARIS__) || defined(__CCI_HPUX__)|| defined(__CCI_LINUX__)/* 16/09/2001 */
/* ---------------------------------------------------------------- */
/*                     Internal constants                           */
/*                                                                  */
/* The interface expects some CciChar strings to be passed. These   */
/* have to be constructed from char strings using the supplied      */
/* utilities. The char constants are defined here along with the    */
/* static CciChar variables which will contain these constants      */
/* converted into CciChar format.                                   */
/*                                                                  */
/* ---------------------------------------------------------------- */
#define CONST_FFMSG001			"FFMSG001"
CciChar *constFFMSG001			= 0;

#define CONST_PARSER_FACTORY  "ComIbmFFMSG001ParserFactory"
CciChar *constParserFactory	= 0;

#define CONST_NONE				"none"
CciChar *constNone				= 0;

#define CONST_RECORD				"Record"
CciChar *constRecord				= 0;
#endif

void *parseNextItem(CciParser *parser, CciContext *context, CciElement *element);

int WriteElement(CciParser *parser, CciElement *elt);

/********************************************************************************************/
/* DEBUG */
#ifdef WIN32
#ifdef _DEBUG
   FILE *OST = NULL;

   #define DBGPRINTF(x)  {\
   OST = fopen("\\DebugFFMSG001parser.txt","a+"); \
      if(OST) fprintf x; \
         fclose(OST); \
   }
#endif
#endif

#if defined (AIX) || defined (SUN) || defined (HPUX) || defined (LINUX)
#ifdef _DEBUG
   FILE *OST = NULL;

   #define DBGPRINTF(x)  {\
   OST = fopen("/tmp/DebugFFMSG001parser.txt","a+"); \
      if(OST) fprintf x; \
         fclose(OST); \
   }
#endif
#endif
/* DEBUG */
/********************************************************************************************/


#endif
